!BAT
:: GRUB4DOS batch script. See Tutorial at www.rmprepusb.com  Tutorial #72
:: Uses: Adds *.mnu file contents to make a single menu
:: Usage: in menu.lst, put \grub\automenu.bat .automenu (folder that has .mnu files)
::        then load using configfile (md)0x3000+0x50

:: An optional \grub\user.mnu file can be included to contain default menu settings (color etc.)

:: This script used the default image file path as %2 variable - e.g. /_ISO
:: A configfile is generated by this code for all mnu files in the /%2 folder and below
:: 
:: \grub\Auto.bat .Automenu /_ISO
:: Configfile (md)0x3000+0x50
::
:: This script requires GRUB4DOS 2010-12-14 or later.
:: and requires the file /grub/WENV

:: version 3 increase memory from 0x3000+0x10 to 0x3000+0x50
::=============================================================================

::set DD=0
::Uncomment line below to show debug lines
::set DD=1

debug off
checkrange 20101214:-1 read 0x8278 || echo Err.version && exit 1
:: this batch file calls itself, so use the label as the place to jump to
goto %~x1
exit



:.automenu

:: Variables: %0=/grub/automenu.bat %~nx0=automenu.bat %~nx1=.automenu %1=.automenu %~x1=.automenu
::echo 0=%0 nx0=%~nx0 nx1=%~nx1 nx2=%~nx2 nx3=%~nx3 1=%1 x1=%~x1
:: get the menu folder into DIR variable
::echo AUTOMENU: checking if wenv is loaded - if not load it
delmod -l wenv || insmod /grub/WENV
::echo Checking if .makemenu is loaded - if not load it
delmod -l %~nx0 || insmod %0 .makemenu


if "%DD%"=="1" echo Writing default menu entry
if "%DD%"=="1" echo -e default 0\n#timeout 10\n\n > (md)0x3000+0x50
if exist (bd)/grub/user.mnu echo Using default user menu USER.MNU
cat --length=0 (bd)/grub/user.mnu && cat (bd)/grub/user.mnu > (md)0x3000+0x50
set ME=%0

if "%2"=="" goto :endloop
set DIR=%2
echo Using %DIR% as main folder for source and .mnu  files
echo set MFOLDER=%DIR% >> (md)0x3000+0x50


echo Looking for .mnu files starting at %DIR%/
ls %DIR%/ | call :cpa

:endloop
::echo writing back to main menu entry
echo -e -n \ntitle Reboot >> (md)0x3000+0x50
echo -n \nReboot system >> (md)0x3000+0x50
echo -e \nreboot >> (md)0x3000+0x50

:: list menu
::cat (md)0x3000+0x50
::pause

set DD=
set DIR=

:: must set root back!
root (bd)/

if "%EBACKUP%"=="YES" echo BACKING UP TO /grub/BACKUP.lst...
if "%EBACKUP%"=="YES" cat (md)0x3000+0x50 > (bd)/grub/BACKUP.lst
if "%EBACKUP%"=="YES" pause

debug on
exit

:: ----------------------- SUBROUTINES ----------------------


:.makemenu
if "%DD%"=="1" echo @MAKEMENU
setlocal
if "%DD%"=="1" echo Checking (bd)%DIR%/%1
if "%1"=="" endlocal && goto :EOF
::If is a directory ignore it
cat --length=0 (bd)%DIR%/%1 || goto :EOF
:: if not mnu file then ignore
if "%DD%"=="1" echo MAKEMENU: checking %~x1 extension 
WENV check "#.mnu#"=="#%~x1#" || goto :EOF
echo ADDING %DIR%/%1 
cat (bd)%DIR%/%1 >> (md)0x3000+0x50
echo >> (md)0x3000+0x50
goto :EOF


:cpa
if "%DD%"=="1" echo @CPA: Current Root: %DIR%
if "%DD%"=="1" echo Change source root to (bd)%DIR%/
root (bd)%DIR%/
ls | call :copyfiles
goto :eof

:copyfiles
if "%DD%"=="1" echo @COPYFILES %1
if "%1"=="" goto :eof
::If is a directory
cat --length=0 /%1 || goto :sub-dir

::copy file
if "%DD%"=="1" echo @COPY FILE
call :.makemenu %1
shift
goto :copyfiles

:sub-dir
if "%DD%"=="1" echo @SUB_DIR %1
setlocal
set DIR=%DIR%/%1
call :cpa
endlocal
shift
goto :copyfiles





